diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria_grade.php mdl20-mitms-integration/lib/completion/completion_criteria_grade.php
--- mdl-cvshead/lib/completion/completion_criteria_grade.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria_grade.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,210 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Course completion critieria - completion on achieving course grade
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+require_once $CFG->dirroot.'/grade/lib.php';
+require_once $CFG->dirroot.'/grade/querylib.php';
+
+/**
+ * Course completion critieria - completion on achieving course grade
+ */
+class completion_criteria_grade extends completion_criteria {
+
+    /**
+     * Criteria type constant
+     * @var int
+     */
+    public $criteriatype = COMPLETION_CRITERIA_TYPE_GRADE;
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['criteriatype'] = COMPLETION_CRITERIA_TYPE_GRADE;
+        return self::fetch_helper('course_completion_criteria', __CLASS__, $params);
+    }
+
+    /**
+     * Add appropriate form elements to the critieria form
+     * @access  public
+     * @param   object  $mform  Moodle forms object
+     * @param   mixed   $data   optional
+     * @return  void
+     */
+    public function config_form_display(&$mform, $data = null) {
+        $mform->addElement('checkbox', 'criteria_grade', get_string('enable'));
+        $mform->addElement('text', 'criteria_grade_value', get_string('passinggrade', 'completion'));
+        $mform->setDefault('criteria_grade_value', $data);
+
+        if ($this->id) {
+            $mform->setDefault('criteria_grade', 1);
+            $mform->setDefault('criteria_grade_value', $this->gradepass);
+        }
+
+        $mform->hardFreeze('criteria_grade_value');
+    }
+
+    /**
+     * Update the criteria information stored in the database
+     * @access  public
+     * @param   array   $data   Form data
+     * @return  void
+     */
+    public function update_config(&$data) {
+
+        // TODO validation
+        if (!empty($data->criteria_grade) && is_numeric($data->criteria_grade_value))
+        {
+            $this->course = $data->id;
+            $this->gradepass = $data->criteria_grade_value;
+            $this->insert();
+        }
+    }
+
+    /**
+     * Get user's course grade in this course
+     * @static
+     * @access  private
+     * @param   object  $completion
+     * @return  float
+     */
+    private function get_grade($completion) {
+        $grade = grade_get_course_grade($completion->userid, $this->course);
+        return $grade->grade;
+    }
+
+    /**
+     * Review this criteria and decide if the user has completed
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @param   boolean $mark           Optionally set false to not save changes to database
+     * @return  boolean
+     */
+    public function review($completion, $mark = true) {
+        // Get user's course grade
+        $grade = $this->get_grade($completion);
+
+        // If user's current course grade is higher than the required pass grade
+        if ($this->gradepass && $this->gradepass <= $grade) {
+            if ($mark) {
+                $completion->gradefinal = $grade;
+                $completion->mark_complete();
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    /**
+     * Return criteria title for display in reports
+     * @access  public
+     * @return  string
+     */
+    public function get_title() {
+        return get_string('grade');
+    }
+
+    /**
+     * Return criteria status text for display in reports
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @return  string
+     */
+    public function get_status($completion) {
+        // Cast as floats to get rid of excess decimal places
+        $grade = (float) $this->get_grade($completion);
+        $gradepass = (float) $this->gradepass;
+
+        if ($grade) {
+            return $grade.'% ('.$gradepass.'% to pass)';
+        } else {
+            return $gradepass.'% to pass';
+        }
+    }
+
+    /**
+     * Find user's who have completed this criteria
+     * @access  public
+     * @return  void
+     */
+    public function cron() {
+        global $DB;
+
+        // Get all users who meet this criteria
+        $sql = '
+            SELECT DISTINCT
+                c.id AS course,
+                cr.date AS date,
+                cr.id AS criteriaid,
+                ra.userid AS userid,
+                gg.finalgrade AS gradefinal
+            FROM
+                {course_completion_criteria} cr
+            INNER JOIN
+                {course} c
+             ON cr.course = c.id
+            INNER JOIN
+                {context} con
+             ON con.instanceid = c.id
+            INNER JOIN
+                {role_assignments} ra
+              ON ra.contextid = con.id
+            INNER JOIN
+                {grade_items} gi
+             ON gi.courseid = c.id
+            AND gi.itemtype = \'course\'
+            INNER JOIN
+                {grade_grades} gg
+             ON gg.itemid = gi.id
+            AND gg.userid = ra.userid
+            LEFT JOIN
+                {course_completion_crit_compl} cc
+             ON cc.criteriaid = cr.id
+            AND cc.userid = ra.userid
+            WHERE
+                cr.criteriatype = '.COMPLETION_CRITERIA_TYPE_GRADE.'
+            AND con.contextlevel = '.CONTEXT_COURSE.'
+            AND c.enablecompletion = 1
+            AND cc.id IS NULL
+            AND gg.finalgrade >= cr.gradepass
+        ';
+
+        // Loop through completions, and mark as complete
+        if ($rs = $DB->get_recordset_sql($sql)) {
+            foreach ($rs as $record) {
+
+                $completion = new completion_criteria_completion((array)$record);
+                $completion->mark_complete();
+            }
+
+            $rs->close();
+        }
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria.php mdl20-mitms-integration/lib/completion/completion_criteria.php
--- mdl-cvshead/lib/completion/completion_criteria.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,207 @@
+<?php
+
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * Course completion criteria
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+require_once($CFG->libdir.'/data_object.php');
+require_once($CFG->libdir.'/completion/completion_criteria_completion.php');
+
+
+/**
+ * Criteria type constants
+ * Primarily for storing criteria type in the database
+ */
+define('COMPLETION_CRITERIA_TYPE_SELF',         1);
+define('COMPLETION_CRITERIA_TYPE_DATE',         2);
+define('COMPLETION_CRITERIA_TYPE_UNENROL',      3);
+define('COMPLETION_CRITERIA_TYPE_ACTIVITY',     4);
+define('COMPLETION_CRITERIA_TYPE_DURATION',     5);
+define('COMPLETION_CRITERIA_TYPE_GRADE',        6);
+define('COMPLETION_CRITERIA_TYPE_ROLE',         7);
+
+/**
+ * Criteria type constant to class name mapping
+ */
+global $COMPLETION_CRITERIA_TYPES;
+$COMPLETION_CRITERIA_TYPES = array(
+    COMPLETION_CRITERIA_TYPE_SELF       => 'self',
+    COMPLETION_CRITERIA_TYPE_DATE       => 'date',
+    COMPLETION_CRITERIA_TYPE_UNENROL    => 'unenrol',
+    COMPLETION_CRITERIA_TYPE_ACTIVITY   => 'activity',
+    COMPLETION_CRITERIA_TYPE_DURATION   => 'duration',
+    COMPLETION_CRITERIA_TYPE_GRADE      => 'grade',
+    COMPLETION_CRITERIA_TYPE_ROLE       => 'role',
+);
+
+
+/**
+ * Completion criteria abstract definition
+ */
+abstract class completion_criteria extends data_object {
+    /**
+     * DB Table
+     * @var string $table
+     */
+    public $table = 'course_completion_criteria';
+
+    /**
+     * Array of required table fields, must start with 'id'.
+     * @var array $required_fields
+     */
+    public $required_fields = array('id', 'course', 'criteriatype', 'module', 'moduleinstance', 'enrolperiod', 'date', 'gradepass', 'role');
+
+    /**
+     * Course id
+     * @var     int
+     */
+    public $course;
+
+    /**
+     * Criteria type
+     * One of the COMPLETION_CRITERIA_TYPE_* constants
+     * @var     int
+     */
+    public $criteriatype;
+
+    /**
+     * Module type this criteria relates to (for activity criteria)
+     * @var     string
+     */
+    public $module;
+
+    /**
+     * Course module instance id this criteria relates to (for activity criteria)
+     * @var     int
+     */
+    public $moduleinstance;
+
+    /**
+     * Period after enrolment completion will be triggered (for period criteria)
+     * @var     int     (days)
+     */
+    public $enrolperiod;
+
+    /**
+     * Date of course completion (for date criteria)
+     * @var     int     (timestamp)
+     */
+    public $date;
+
+    /**
+     * Passing grade required to complete course (for grade completion)
+     * @var     float
+     */
+    public $gradepass;
+
+    /**
+     * Role ID that has the ability to mark a user as complete (for role completion)
+     * @var     int
+     */
+    public $role;
+
+    /**
+     * Finds and returns all data_object instances based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return array array of data_object insatnces or false if none found.
+     */
+    public static function fetch_all($params) {}
+
+    /**
+     * Factory method for creating correct class object
+     * @static
+     * @param   array
+     * @return  object
+     */
+    public static function factory($params) {
+        global $CFG, $COMPLETION_CRITERIA_TYPES;
+
+        if (!isset($COMPLETION_CRITERIA_TYPES[$params->criteriatype])) {
+            throw new moodle_exception('invalidcriteriatype', 'completion');
+        }
+
+        $class = 'completion_criteria_'.$COMPLETION_CRITERIA_TYPES[$params->criteriatype];
+        require_once($CFG->libdir.'/completion/'.$class.'.php');
+
+        return new $class($params, false);
+    }
+
+    /**
+     * Add appropriate form elements to the critieria form
+     * @access  public
+     * @param   object  $mform  Moodle forms object
+     * @param   mixed   $data   optional
+     * @return  void
+     */
+    abstract public function config_form_display(&$mform, $data = null);
+
+    /**
+     * Update the criteria information stored in the database
+     * @access  public
+     * @param   array   $data   Form data
+     * @return  void
+     */
+    abstract public function update_config(&$data);
+
+    /**
+     * Review this criteria and decide if the user has completed
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @param   boolean $mark           Optionally set false to not save changes to database
+     * @return  boolean
+     */
+    abstract public function review($completion, $mark = true);
+
+    /**
+     * Return criteria title for display in reports
+     * @access  public
+     * @return  string
+     */
+    abstract public function get_title();
+
+    /**
+     * Return criteria status text for display in reports
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @return  string
+     */
+    public function get_status($completion) {
+        return $completion->is_complete() ? get_string('yes') : get_string('no');
+    }
+
+    /**
+     * Return true if the criteria's current status is different to what is sorted
+     * in the database, e.g. pending an update
+     *
+     * @param object $completion The user's criteria completion record
+     * @return bool
+     */
+    public function is_pending($completion) {
+        $review = $this->review($completion, false);
+
+        return $review !== $completion->is_complete();
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria_role.php mdl20-mitms-integration/lib/completion/completion_criteria_role.php
--- mdl-cvshead/lib/completion/completion_criteria_role.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria_role.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,123 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Course completion critieria - marked by role
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class completion_criteria_role extends completion_criteria {
+
+    /**
+     * Criteria type constant
+     * @var int
+     */
+    public $criteriatype = COMPLETION_CRITERIA_TYPE_ROLE;
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['criteriatype'] = COMPLETION_CRITERIA_TYPE_ROLE;
+        return self::fetch_helper('course_completion_criteria', __CLASS__, $params);
+    }
+
+   /**
+     * Add appropriate form elements to the critieria form
+     * @access  public
+     * @param   object  $mform  Moodle forms object
+     * @param   mixed   $data   optional
+     * @return  void
+     */
+    public function config_form_display(&$mform, $data = null) {
+
+        $mform->addElement('checkbox', 'criteria_role['.$data->id.']', $data->name);
+
+        if ($this->id) {
+            $mform->setDefault('criteria_role['.$data->id.']', 1);
+        }
+    }
+
+     /**
+     * Update the criteria information stored in the database
+     * @access  public
+     * @param   array   $data   Form data
+     * @return  void
+     */
+    public function update_config(&$data) {
+
+        if (!empty($data->criteria_role) && is_array($data->criteria_role)) {
+
+            $this->course = $data->id;
+
+            foreach (array_keys($data->criteria_role) as $role) {
+
+                $this->role = $role;
+                $this->id = NULL;
+                $this->insert();
+            }
+        }
+    }
+
+    /**
+     * Mark this criteria as complete
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @return  void
+     */
+    public function complete($completion) {
+        $this->review($completion, true, true);
+    }
+
+    /**
+     * Review this criteria and decide if the user has completed
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @param   boolean $mark           Optionally set false to not save changes to database
+     * @return  boolean
+     */
+    public function review($completion, $mark = true, $is_complete = false)  {
+        // If we are marking this as complete
+        if ($is_complete && $mark)
+        {
+            $completion->completedself = 1;
+            $completion->mark_complete();
+
+            return true;
+        }
+
+        return $completion->is_complete();
+    }
+
+    /**
+     * Return criteria title for display in reports
+     * @access  public
+     * @return  string
+     */
+    public function get_title() {
+        global $DB;
+        $role = $DB->get_field('role', 'name', array('id' => $this->role));
+        return $role;
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria_self.php mdl20-mitms-integration/lib/completion/completion_criteria_self.php
--- mdl-cvshead/lib/completion/completion_criteria_self.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria_self.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,112 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Course completion critieria - student self marked
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class completion_criteria_self extends completion_criteria {
+
+    /**
+     * Criteria type constant
+     * @var int
+     */
+    public $criteriatype = COMPLETION_CRITERIA_TYPE_SELF;
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['criteriatype'] = COMPLETION_CRITERIA_TYPE_SELF;
+        return self::fetch_helper('course_completion_criteria', __CLASS__, $params);
+    }
+
+    /**
+     * Add appropriate form elements to the critieria form
+     * @access  public
+     * @param   object  $mform  Moodle forms object
+     * @param   mixed   $data   optional
+     * @return  void
+     */
+    public function config_form_display(&$mform, $data = null) {
+        $mform->addElement('checkbox', 'criteria_self', get_string('enable'));
+
+        if ($this->id ) {
+           $mform->setDefault('criteria_self', 1);
+        }
+    }
+
+    /**
+     * Update the criteria information stored in the database
+     * @access  public
+     * @param   array   $data   Form data
+     * @return  void
+     */
+    public function update_config(&$data) {
+        if (!empty($data->criteria_self)) {
+            $this->course = $data->id;
+            $this->insert();
+        }
+    }
+
+    /**
+     * Mark this criteria as complete
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @return  void
+     */
+    public function complete($completion) {
+        $this->review($completion, true, true);
+    }
+
+    /**
+     * Review this criteria and decide if the user has completed
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @param   boolean $mark           Optionally set false to not save changes to database
+     * @return  boolean
+     */
+    public function review($completion, $mark = true, $is_complete = false) {
+        // If we are marking this as complete
+        if ($is_complete && $mark)
+        {
+            $completion->completedself = 1;
+            $completion->mark_complete();
+
+            return true;
+        }
+
+        return $completion->is_complete();
+    }
+
+    /**
+     * Return criteria title for display in reports
+     * @access  public
+     * @return  string
+     */
+    public function get_title() {
+        return get_string('selfcompletion', 'completion');
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_criteria_unenrol.php mdl20-mitms-integration/lib/completion/completion_criteria_unenrol.php
--- mdl-cvshead/lib/completion/completion_criteria_unenrol.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_criteria_unenrol.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,94 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Course completion critieria - completion on unenrolment
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class completion_criteria_unenrol extends completion_criteria {
+
+    /**
+     * Criteria type constant
+     * @var int
+     */
+    public $criteriatype = COMPLETION_CRITERIA_TYPE_UNENROL;
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        $params['criteriatype'] = COMPLETION_CRITERIA_TYPE_UNENROL;
+        return self::fetch_helper('course_completion_criteria', __CLASS__, $params);
+    }
+
+    /**
+     * Add appropriate form elements to the critieria form
+     * @access  public
+     * @param   object  $mform  Moodle forms object
+     * @param   mixed   $data   optional
+     * @return  void
+     */
+    public function config_form_display(&$mform, $data = null) {
+        $mform->addElement('checkbox', 'criteria_unenrol', 'Completion on unenrolment');
+
+        if ($this->id) {
+            $mform->setDefault('criteria_unenrol', 1);
+        }
+    }
+
+    /**
+     * Update the criteria information stored in the database
+     * @access  public
+     * @param   array   $data   Form data
+     * @return  void
+     */
+    public function update_config(&$data) {
+        if (!empty($data->criteria_unenrol)) {
+            $this->course = $data->id;
+            $this->insert();
+        }
+    }
+
+    /**
+     * Review this criteria and decide if the user has completed
+     * @access  public
+     * @param   object  $completion     The user's completion record
+     * @param   boolean $mark           Optionally set false to not save changes to database
+     * @return  boolean
+     */
+    public function review($completion, $mark = true) {
+        // Check enrolment
+        return false;
+    }
+
+    /**
+     * Return criteria title for display in reports
+     * @access  public
+     * @return  string
+     */
+    public function get_title() {
+        return get_string('unenrol');
+    }
+}
